`timescale 10ps / 10ps
`define GTK // use VCD

`define MODULE	tb_counter
`ifdef CLK_LIMIT
`else
`define CLK_LIMIT	200
`endif

module `MODULE;

   reg [23:0] CLK_COUNT;
   reg CLK;   // input
   reg I; // input
   reg R; // input
   wire O;

button top
	( .CLK_128HZ(CLK) 
		, .I(I)
		, .O(O)
		, .R(R)
		);

   parameter CLKP = 5000000;        //  50us
   parameter CLKH = CLKP/2;      //
   parameter CLKL = CLKP-CLKH;   //
   
   always begin
      #CLKH CLK = 0;
      #CLKL CLK = 1;
   end

`ifdef GTK
   initial begin
      $dumpfile("tb.vcd");
      $dumpvars(0,`MODULE.top);
   end
`endif

   initial begin : test
      CLK_COUNT = 0;
      I = 1'b0;
      R = 1'b0;
      //sys_reset();
      while ( (CLK_COUNT < `CLK_LIMIT) )
      begin
         @(posedge CLK);
         CLK_COUNT = CLK_COUNT + 1;
	if (CLK_COUNT == 20) I = 1'b1;
	if (CLK_COUNT == 25) I = 1'b0;
	if (CLK_COUNT == 30)
	begin
		R = 1'b1;
		# 5000	
		R = 1'b0;
	end
	if (CLK_COUNT == 40) I = 1'b1;
	if (CLK_COUNT == 45)
	begin
		R = 1'b1;
		# 5000	
		R = 1'b0;
	end
	if (CLK_COUNT == 50) I = 1'b0;
      end
//      @(posedge CLK);
      #1
      $display("*** Simulation Complete! ***");
      $finish;
   end

   task sys_reset;
      begin
         //PC2 = 0;
         //#1 RESET = 1;
         //CLK2X = 0;
         @(posedge CLK);
         @(posedge CLK);
         //#1 RESET = 0;
         @(posedge CLK);
         @(posedge CLK);
         CLK_COUNT = CLK_COUNT + 1;
      end
   endtask // sys_reset
   
endmodule // test
